/*
    Performancing for Firefox Spell Check for Firefox 2.0beta1
    Author: Jed Brown (http://jedbrown.net/contact)
    
    A modified version of the JS from textbox.xml since editor's do not inherite spellchecking (why?)
    This spell checking code only works in Firefox 2.0b1 and not tested on anything later
*/
var gSpelltest = null;
var dsSpellCheck = new Object();
var gTheTabHTMLEditor;
dsSpellCheck = {
    isFx2orGreater: false
}

dsSpellCheck.setupSpellCheck = function() {
    //Only if Firefox 2.0 and greater
    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                        .getService(Components.interfaces.nsIXULAppInfo);
    var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
                                   .getService(Components.interfaces.nsIVersionComparator);
                                   //versionChecker.compare(appInfo.version, "1.5") > 0
    if(parseInt(appInfo.version) >= 2) {
      // running under Firefox 2.0
      this.isFx2orGreater = true;
      
      var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
              getService(Components.interfaces.mozIJSSubScriptLoader);
            loader.loadSubScript("chrome://global/content/inlineSpellCheckUI.js", this);
            
      var ifPrefTrue = true;
      		var midas = document.getElementById("message");
	gTheTabHTMLEditor = midas.getHTMLEditor(midas.contentWindow);

      if(ifPrefTrue && gTheTabHTMLEditor.isDocumentEditable ){
          this.InlineSpellCheckerUI.mEditor = gTheTabHTMLEditor;
          this.InlineSpellCheckerUI.mInlineSpellChecker = this.InlineSpellCheckerUI.mEditor.inlineSpellChecker;
          this.InlineSpellCheckerUI.enabled = true;
      }
    }else{
        //Hide the menu stuff
        this._setNoSpellCheckingAllowed();
    }
}

dsSpellCheck._delayedInitSpellCheck = function(popupNode){
    
}
    
dsSpellCheck._doPopupItemEnabling = function(popupNode){
    if(this.isFx2orGreater){
    // -- spell checking --

            // try to find the outer textbox for this box, don't search
            // up too far.
            gSpelltest = popupNode;
            /*
            var textboxElt = popupNode;
            for (var i = 0; i < 5; i ++) {
              if (textboxElt.localName == "editor")
                break;
              textboxElt = textboxElt.parentNode;
            }
            if (textboxElt.tagName != "editor") {
              // can't find it, give up
              this._setNoSpellCheckingAllowed();
              return;
            }
            */
            //var spellui = textboxElt.spellCheckerUI;
            var spellui = this.InlineSpellCheckerUI;
            this.spellui = spellui;

            if (! spellui.canSpellCheck)
            {
              this._setNoSpellCheckingAllowed();
              return;
            }

            spellui.initFromEvent(document.popupRangeParent,
                                  document.popupRangeOffset);

            var enabled = spellui.enabled;
            document.getElementById("spell-check-enabled").setAttribute("checked", enabled);

            var overMisspelling = spellui.overMisspelling;
            this._setMenuItemVisibility("spell-add-to-dictionary", overMisspelling);
            this._setMenuItemVisibility("spell-suggestions-separator", overMisspelling);

            // suggestion list
            var spellSeparator = document.getElementById("spell-suggestions-separator");
            var numsug = spellui.addSuggestionsToMenu(popupNode, spellSeparator, 5);
            this._setMenuItemVisibility("spell-no-suggestions", overMisspelling && numsug == 0);

            // dictionary list
            var dictmenu = document.getElementById("spell-dictionaries-menu");
            //var dictmenu = document.getElementById("spell-dictionaries");
            var numdicts = spellui.addDictionaryListToMenu(dictmenu, null);
            this._setMenuItemVisibility("spell-dictionaries", enabled && numdicts > 1);
    }
}

dsSpellCheck._doPopupItemDisabling = function(popupNode){
    if (this.isFx2orGreater && this.spellui) {
            this.spellui.clearSuggestionsFromMenu();
            this.spellui.clearDictionaryListFromMenu();
    }
}

dsSpellCheck._setMenuItemVisibility = function(anonid, visible){
    document.getElementById(anonid).hidden = !visible;
}

dsSpellCheck._setNoSpellCheckingAllowed = function(){
    this._setMenuItemVisibility("spell-no-suggestions", false);
    this._setMenuItemVisibility("spell-check-enabled", false);
    this._setMenuItemVisibility("spell-check-separator", false);
    this._setMenuItemVisibility("spell-add-to-dictionary", false);
    this._setMenuItemVisibility("spell-suggestions-separator", false);
    this._setMenuItemVisibility("spell-dictionaries", false);
}

dsSpellCheck.addToDictionary = function(){
    try{
        dsSpellCheck.spellui.addToDictionary();
    }catch(e){}
}

dsSpellCheck.toggleEnabled = function(){
    try{
        dsSpellCheck.spellui.toggleEnabled();
    }catch(e){}
}

dsSpellCheck.spellCheckNow = function(){
    dsSpellCheck.spellui.mInlineSpellChecker.enableRealTimeSpell = true;
}

dsSpellCheck.dummy = function(){
    //foo
}

